
![Pele Logo](docs/source/pele_logo_2.png)
--------------------------------------------------------------------------------

Pele is a diverse and flexible library designed for research into sequence to sequence learning, primarily in
hierarchical vision tasks such as video captioning, and video activity recognition. There are often many moving parts to
building systems for these tasks, and Pele is designed to help alleviate much of the stress, time, and headache associated
with video data, and sequence to sequence learning.

- [Installation](#installation)
  - [From Source](#from-source)
- [Getting Started](#getting-started)
- [The Team](#the-team)


## Installation

### From Source

You need to have the following requirements to install the pele library:

    - torch>=1.4
    - torchvision>=0.5
    - numpy>=1.18
    - sentencepiece>=0.1.8
    - gin-config>=0.3.0
    - Click>=7.0
    - ray>=0.9.0.dev0
    - apex>=0.1
    - tensorboardX>=2.0  # Unmarked Ray dependency
    - requests>=2.23.0  # Unmarked Ray dependency
    - pandas>=1.0.1  # Unmarked Ray dependency
    - tabulate>=0.8.6  # Unmarked Ray dependency

There are two of these dependencies which are tricky to install. Apex should be installed following the instructions at
https://github.com/NVIDIA/apex, while Ray's development version can be installed by following the nightly build
instructions at https://ray.readthedocs.io/en/latest/installation.html.

Once installing Apex and Ray, we can clone this repository [here](https://github.com/davidmchan/pele.git) and then run the
following from the repository directory:

```bash
pip install -e .
```

## Getting Started

For all of the details, check out our documentation [here]().

Every experiment is specified by a [gin-config](https://github.com/google/gin-config) file, outlining the data sources,
the model, the losses, and the training procedure.

To get started, check out the sample experiments in `examples/`. You can run any training experiment by using the command:
```bash
pele train [Experiment .gin File]
```

## The Team

Pele is currently maintained by [David Chan](https://github.com/DavidMChan), and the team at the CannyLab at the University of California, Berkeley.

## License

Pele is licensed under Apache 2.0, as found in the LICENSE file.
