import gin

from pele.config.util import ConfigClass
from pele.core.data.features import YamlFeature, NumpyFeature, JSONFeature

# Setup feature type constants
gin.constant('YAML', YamlFeature)
gin.constant('NUMPY', NumpyFeature)
gin.constant('JSON', JSONFeature)


@gin.configurable('data')
class DataConfig(ConfigClass):

    def __init__(self, features=gin.REQUIRED, db_limit=None):
        self.features = features
        self.db_limit = db_limit
