import gin

from pele.config.util import ConfigClass
from pele.core.data.extractors import Resnet18FeatureExtractor, LearnedLMEmbedding, TokenizationPreprocessor

# Setup feature extraction constants
gin.constant('Resnet18', Resnet18FeatureExtractor)
gin.constant('Tokenizer', TokenizationPreprocessor)
gin.constant('LearnedEmbedding', LearnedLMEmbedding)


@gin.configurable('feature_extraction')
class FeatureExtractorConfig(ConfigClass):

    def __init__(self, fe_map=None):
        self.feature_extractor_map = fe_map if fe_map else dict()
