import torch


class LearnedLMEmbedding(torch.nn.Module):

    def __init__(self, vocab_size, embedding_dimension, input_key, output_key):
        super(LearnedLMEmbedding, self).__init__()

        self.vocab_size = vocab_size
        self.embedding_dimension = embedding_dimension
        self.input_key = input_key
        self.output_key = output_key

        self.embedding_layer = torch.nn.Embedding(self.vocab_size, self.embedding_dimension)

    def forward(self, inputs):
        embedded = self.embedding_layer(inputs[self.input_key])
        return {self.output_key: embedded}
