import gin
import torch

class MeanFusionModel(torch.nn.Module):

    def __init__(self, features, output_key='context'):
        super(MeanFusionModel, self).__init__()
        self.features = features
        self.output_key = output_key

    def forward(self, inputs):
        return {self.output_key: torch.mean(torch.cat([v for k, v in inputs.items() if k in self.features], dim=1), dim=1)}
