import logging
import sys

_RUN_LOGDIR = None

def get_logdir():
    global _RUN_LOGDIR
    if _RUN_LOGDIR is None:
        raise RuntimeError('You should call init_logging before trying to get the log directory.')
    return _RUN_LOGDIR


def init_logging(log_config, rank=0):
    global _RUN_LOGDIR
    root = logging.getLogger()
    root.setLevel(log_config.loglevel)

    handler = logging.StreamHandler(sys.stdout)
    handler.setLevel(log_config.loglevel)
    formatter = logging.Formatter(log_config.log_format_string)
    handler.setFormatter(formatter)
    root.addHandler(handler)
    _RUN_LOGDIR = log_config.logdir

    # Setup wandb if enables
    if log_config.use_wandb and rank <= 0:
        import wandb
        wandb.init(project=log_config.wandb_project, tags=','.join(log_config.wandb_tags))


        
